//    WeIRCd administration tool
//    Copyright (C) 2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "admintool.h"

 char picdir[150] = "";
 char gtkdir[150] = "gtk/";

int restartscheduled = 0;
 
int gui_wantquit = 0;
GtkWidget *mainwindow = NULL;
	GtkWidget* vbox_menubar_content;
		GtkWidget* menubar;
			GtkWidget* menu_admintool;
				GtkWidget* adminmenu;
					GtkWidget* adminm_connect;
					GtkWidget* adminm_sep;
					/*GtkWidget* adminm_preferences;
					GtkWidget* adminm_sep2;*/
					GtkWidget* adminm_quit;
			GtkWidget* menu_currentconnection;
				GtkWidget* connectionmenu;
					GtkWidget* connm_connect;
					GtkWidget* connm_disconnect;
					GtkWidget* connm_sep;
					GtkWidget* connm_reconnect;
					GtkWidget* connm_sep2;
					GtkWidget* connm_closetab;
			GtkWidget* menu_servercontrol;
				GtkWidget* controlmenu;
					GtkWidget* control_start;
					GtkWidget* control_restart;
					GtkWidget* control_stop;
					GtkWidget* control_sep;
					GtkWidget* control_reloadconfig;
					GtkWidget* control_checkforupdate;
					GtkWidget* control_sep2;
					GtkWidget* control_serverlinking;
			GtkWidget* menu_help;
				GtkWidget* helpmenu;
					GtkWidget* help_whp;
					GtkWidget* help_wdocs;
					GtkWidget* help_eprojects;
					GtkWidget* help_sep;
					GtkWidget* help_about;
		GtkWidget* tabs;

#define LOCALPARSE_STARTING 0
#define LOCALPARSE_NOWRUNNING 1
#define LOCALPARSE_READINGERROR 2

int localpid = -1;


void* tablist = NULL;
GtkWidget* imgmitem(const char* mnemonic, const gchar* id) {
	GtkWidget* m = gtk_image_menu_item_new_with_mnemonic(mnemonic);
	GtkWidget* i = gtk_image_new_from_stock(id,GTK_ICON_SIZE_MENU);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m), i);
	gtk_widget_show(m);
	return m;
}
void* listoftabs = NULL;
static gint do_popup_menu (GtkWidget *my_widget, GdkEventButton *event);
void* gui_mainwindow_AddTab(const char* title) {
	struct tab t;memset(&t,0,sizeof(t));
	GtkWidget* lbl = gtk_label_new(title);gtk_widget_show(lbl);
	GtkWidget* b = gtk_vbox_new(FALSE,2);
	t.tab = gtk_notebook_append_page(GTK_NOTEBOOK(tabs),b,lbl);
	gtk_widget_show(b);
	t.box = b;
	g_signal_connect (tabs, "button-press-event", 
			G_CALLBACK (do_popup_menu), NULL);
	return linkedlist_Append(&tablist, &t, sizeof(t));
}
void gui_AdjustButtonsToTab(void* tab) {
	struct tab* t = linkedlist_GetData(tab);
	if (t->remote == 0) {
		gui_mainwindow_menus_Connected(0); //param: 0 = no remote
		if (t->running > 0) {
			printf("running local %d %d %d\n",t->running,t->havepipes, t->localparsestate);
			gtk_widget_set_sensitive(control_start, FALSE);
			gtk_widget_set_sensitive(control_restart, FALSE);
			gtk_widget_set_sensitive(control_stop, FALSE);
			gtk_widget_set_sensitive(control_reloadconfig, FALSE);
			if (t->running == 1 && t->wanttostop <= 0) {
				gtk_widget_set_sensitive(control_restart, TRUE);
				gtk_widget_set_sensitive(control_stop, TRUE);
				gtk_widget_set_sensitive(control_reloadconfig, TRUE);
			}
		}
		if (t->running == 0) {
			printf("stopped local\n");
			if (t->restartscheduled <= 0) {
				gtk_widget_set_sensitive(control_start, TRUE);
			}else{
				gtk_widget_set_sensitive(control_start, FALSE);
			}
			gtk_widget_set_sensitive(control_restart, FALSE);
			gtk_widget_set_sensitive(control_stop, FALSE);
			gtk_widget_set_sensitive(control_reloadconfig, FALSE);
		}
		gui_TabButtons(tab);
	}else{
		printf("remote or no context %d\n",t->remote);
		if (t->remote == 1) {
			if (t->connected == 1) {
				gui_mainwindow_menus_Connected(1); //param: 1 = have remote
			}else{
				gui_mainwindow_menus_Disconnected();
			}
		}else{
			gui_mainwindow_menus_NoContext();
		}
		gui_TabButtons(tab);
	}
}
void* gui_GetCurrentTab() {
	int i = gtk_notebook_get_current_page(GTK_NOTEBOOK(tabs));
	if (i < 0) {return NULL;}
	void* item = tablist;
	while (item != NULL) {
		struct tab* t = linkedlist_GetData(item);
		if (t->tab == i) {
			return item;
		}
		item = linkedlist_NextItem(item);
	}
	return NULL;
}
void gui_TabButtons(void* tptr) { /* adjust buttons of our control notebook/tab */
	struct tab* t = linkedlist_GetData(tptr);
	if (t->ct.tabc_start == NULL) {return;}
	gtk_widget_set_sensitive(t->ct.tabc_start,FALSE);
	gtk_widget_set_sensitive(t->ct.tabc_restart,FALSE);
	gtk_widget_set_sensitive(t->ct.tabc_stop,FALSE);
	gtk_widget_set_sensitive(t->ct.tabc_rehash,FALSE);
	if (t->remote >= 0) {
		if (t->running > 0) {
			//all decativated while we startup
			if (t->running == 1) {
				if (t->wanttostop <= 0) {
					gtk_widget_set_sensitive(t->ct.tabc_stop,TRUE);
					gtk_widget_set_sensitive(t->ct.tabc_rehash,TRUE);
					gtk_widget_set_sensitive(t->ct.tabc_restart,TRUE);
				}
			}
		}
		if (t->running == 0) {
			if (t->restartscheduled <= 0) {
				gtk_widget_set_sensitive(t->ct.tabc_start,TRUE);
			}else{
				gtk_widget_set_sensitive(t->ct.tabc_start,FALSE);
			}
		}
	}else{
		
	}
}
void gui_AddLocalInstTab() {
	void* tptr;struct tab* t;
	if (localinstallationfound != 0) {
#ifdef WIN
		tptr = gui_mainwindow_AddTab("<No local installation found>");
#endif
#ifndef WIN
		tptr = gui_mainwindow_AddTab("<Empty>");
#endif
		t = linkedlist_GetData(tptr);
		t->remote = -1;
		gui_TabButtons(tptr);
		gui_AdjustButtonsToTab(tptr);
		return;
	}else{
		const char* p = localinstall_GetVersion();
		
		tptr = gui_mainwindow_AddTab(localinstall_GetDataDir());
		
		t = linkedlist_GetData(tptr);
		t->remote = 0;
		printf("remote is now %d\n",t->remote);
		t->connected = 1;
		if (p != NULL) {
			t->versionstr = malloc(strlen(p)+1);strcpy(t->versionstr,p);
		}
		printf("remote is now %d\n",t->remote);
		localpid = -1;
		gui_controlnotebook_CreateDefault(t,&t->ct,t->box,p);
		printf("remote is now %d\n",t->remote);
		if (p == NULL) {
			gui_controlnotebook_Msg(&t->ct,"Failed to obtain <b>server version</b>. That probably means you are using an <b>incompatible server version</b>.",MSGTYPE_ERROR);	
		}
		printf("remote is now %d\n",t->remote);
#ifdef WIN
		if (diskconfig_Load() < 0) {
			gtk_widget_set_sensitive(t->ct.s.parentframe,FALSE);
			gui_controlnotebook_Msg(&t->ct,"Failed to open/read the configuration file.",MSGTYPE_ERROR);
		}else{
			transfer_configtogui(NULL);
		}
#endif
	}
	if (localinstall_IsServerRunning(&localpid) == 0) {
		t->running = 1;
		gui_controlbook_Value(t->ct.value_status,"Running",0);
	}else{
		localpid = -1;
		t->running = 0;
	}
	gui_AdjustButtonsToTab(tptr);
	gui_TabButtons(tptr);
	printf("remote is now %d\n",t->remote);
}
int gui_UpdateTabConfig(struct tab* t) {
	if (t->remote == 0) {
		int i = 0;
		i = diskconfig_WriteUpdate();
		if (i < 0) {return -1;}
		return 0;
	}else{
		return 0;
	}
}
void gui_AddEmptyTab() {
	void* tptr;struct tab* t;
	tptr = gui_mainwindow_AddTab("<Empty>");
	t = linkedlist_GetData(tptr);
	t->remote = -1;
	gui_TabButtons(tptr);
	gui_AdjustButtonsToTab(tptr);
	return;
}
		
static void gevent_mainwindow_destroy( GtkWidget *widget,
                     gpointer   data ) {
	//gui_wantquit = 1;
	gtk_main_quit();
}
static void gevent_mainwindow_connecttoinstance( GtkWidget *widget,
                     gpointer   data ) {
	GtkWidget* dlg = gtk_message_dialog_new(NULL,0,
	GTK_MESSAGE_ERROR,
	GTK_BUTTONS_OK,
	"This is not implemented yet.",NULL);
	gtk_window_set_title(GTK_WINDOW(dlg),"Fatal error");
	gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER);
	gtk_dialog_run(GTK_DIALOG(dlg));
	gtk_widget_hide(dlg);
	gtk_widget_destroy(dlg);
}
void mainwindowaction_RehashServer() {
	printf("attempting to rehash\n");
	void* tptr = gui_GetCurrentTab();
	if (tptr == NULL) {return;}
	struct tab* t = linkedlist_GetData(tptr);
	if (t->running <= 0) {return;}
	if (t->connected == 0 && t->remote == 1) {return;}
	if (t->remote == 0 && localpid < 0) {return;}
	gui_controlbook_RemoveMsg(&t->ct);
	if (t->remote == 0) {
		localinstall_RehashSig(localpid);
	}
}
void mainwindowaction_StopServer() {
	void* tptr = gui_GetCurrentTab();
	if (tptr == NULL) {return;}
	struct tab* t = linkedlist_GetData(tptr);
	if (t->running <= 0) {return;}
	if (t->connected == 0 && t->remote == 1) {return;}
	if (t->remote == 0 && localpid < 0) {return;}
	gui_controlbook_RemoveMsg(&t->ct);
	
	if (t->remote == 0) {
		localinstall_TermSig(localpid);
		printf("message sent\n");
		t->wanttostop = 1;
		gtk_widget_set_sensitive(control_reloadconfig, FALSE);
		gtk_widget_set_sensitive(control_stop, FALSE);
		gtk_widget_set_sensitive(control_restart, FALSE);
		gtk_widget_set_sensitive(t->ct.tabc_restart, FALSE);
		gtk_widget_set_sensitive(t->ct.tabc_stop, FALSE);
		gtk_widget_set_sensitive(t->ct.tabc_rehash, FALSE);
	}else{
		GtkWidget* dlg = gtk_message_dialog_new(NULL,0,
		GTK_MESSAGE_ERROR|GTK_DIALOG_MODAL,
		GTK_BUTTONS_OK,
		"Not implemented yet",NULL);
		gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER);
		gtk_window_set_title(GTK_WINDOW(dlg),"Fatal error");
		gtk_widget_show(GTK_WIDGET(dlg));
	}
}
void mainwindow_dlg_ResponseStopServer(GtkDialog *dialog, gint arg1, gpointer user_data) {
	gtk_widget_hide(GTK_WIDGET(dialog));gtk_widget_destroy(GTK_WIDGET(dialog));
	if (arg1 != GTK_RESPONSE_YES) {
		return;
	}
	mainwindowaction_StopServer();
}
void mainwindow_dlg_AskStopServer() {
	GtkWidget* dlg = gtk_message_dialog_new(NULL,0,
	GTK_MESSAGE_WARNING|GTK_DIALOG_MODAL,
	GTK_BUTTONS_YES_NO,
	"This will disconnect all users currently connected to this server. Continue?",NULL);
	gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER);
	gtk_window_set_title(GTK_WINDOW(dlg),"Warning");
	gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
	gtk_widget_show(dlg);
	g_signal_connect (dlg, "response", 
			G_CALLBACK (mainwindow_dlg_ResponseStopServer), NULL);
}
void mainwindow_dlg_ResponseRestartServer(GtkDialog *dialog, gint arg1, gpointer user_data) {
	gtk_widget_hide(GTK_WIDGET(dialog));gtk_widget_destroy(GTK_WIDGET(dialog));
	if (arg1 != GTK_RESPONSE_YES) {
		return;
	}
	mainwindowaction_RestartServer();
}
void mainwindow_dlg_AskRestartServer() {
	GtkWidget* dlg = gtk_message_dialog_new(NULL,0,
	GTK_MESSAGE_WARNING|GTK_DIALOG_MODAL,
	GTK_BUTTONS_YES_NO,
	"This will temporarily disconnect all users currently connected to this server. Continue?",NULL);
	gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER);
	gtk_window_set_title(GTK_WINDOW(dlg),"Warning");
	gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
	gtk_widget_show(dlg);
	g_signal_connect (dlg, "response", 
			G_CALLBACK (mainwindow_dlg_ResponseRestartServer), NULL);
}
void mainwindowaction_RestartServer() {
	void* tptr = gui_GetCurrentTab();
	if (tptr == NULL) {return;}
	struct tab* t = linkedlist_GetData(tptr);
	if (t->running == 0) {return;}
	t->restartscheduled = 1;
	mainwindowaction_StopServer();
}
void mainwindow_localserver_start() {
	struct tab* t = NULL;
	void* item = tablist;
	while (item != NULL) {
		struct tab *findtab = linkedlist_GetData(item);
		if (findtab->remote == 0) {
			t = findtab;
			break;
		}
		item = linkedlist_NextItem(item);
	}
	if (t == NULL) {return;}
	int i = localinstall_Run(&t->readfrompipe,&t->writetopipe);
	if (i < 0) {
		//display error message
		char errormsg[1000];
		snprintf(errormsg,999,"Unable to startup server daemon located at \"%s\":\n\n%s\n",localinstall_GetBinPath(),localinstall_GetProcessStartError());
		errormsg[999] = 0;
		GtkWidget* dlg = gtk_message_dialog_new(NULL,0,
		GTK_MESSAGE_ERROR,
		GTK_BUTTONS_OK,
		errormsg,NULL);
		gtk_window_set_title(GTK_WINDOW(dlg),"Fatal error");
		gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER);
		gtk_dialog_run(GTK_DIALOG(dlg));
		gtk_widget_hide(dlg);
		gtk_widget_destroy(dlg);
		return;
	}else{
		t->running = 2;t->havepipes = 1;gui_AdjustButtonsToTab(item);
		t->localparsestate = LOCALPARSE_STARTING;
		strcpy(t->buf,"");
		gui_controlbook_Value(t->ct.value_status,"Starting...",0);
		//localinstall_CheckPipe(t->readfrompipe);
	}
}
void mainwindowaction_StartServer() {
	void* tptr = gui_GetCurrentTab();
	if (tptr == NULL) {return;}
	struct tab* t = linkedlist_GetData(tptr);
	if (t->running == 1) {return;}
	if (t->connected == 0 && t->remote == 1) {return;}
	mainwindow_localserver_start();
}
void mainwindow_ParsePipeLine(const char* line, void* tptr) {
	struct tab* t = linkedlist_GetData(tptr);
	char* copy = alloca(strlen(line)+1);
	strcpy(copy,line);
	if (charpos(copy,'\n') >= 0) {copy[charpos(copy,'\n')] = 0;}
	if (charpos(copy,'\r') >= 0) {copy[charpos(copy,'\r')] = 0;}
	//printf("> %s\n",copy);
	if (t->localparsestate == LOCALPARSE_STARTING) {
		if (stringisinstring(copy,"Error while loading config") >= 0 || stringisinstring(copy,"Parsing config failed") >= 0) {
			t->localparsestate = LOCALPARSE_READINGERROR;
		}
		if (stringisinstring(copy,"FATAL ERROR, terminating") >= 0) {
			gui_controlnotebook_Msg(&t->ct,"WeIRCd failed to startup due to an <b>unknown error</b>.",MSGTYPE_ERROR);
			t->havepipes = 0;
			localinstall_ClosePipes(t->readfrompipe,t->writetopipe);
			return;
		}
		if (stringisinstring(copy,"WARNING: Failed to open one or more ports") >= 0) {
			gui_controlnotebook_Msg(&t->ct,"WeIRCd was unable to open all desired ports for listening. This means you can probably not connect to it.\n\nIf the problem persists, stop the server and wait a bit before starting again so the system will release the ports.",MSGTYPE_WARNING);
		}
		if (strendswith(copy,"Running!") == 0 || stringisinstring(copy,"failed to open one or more ports") >= 0) {
			t->havepipes = 0;
			t->localparsestate = LOCALPARSE_NOWRUNNING;
			localinstall_ClosePipes(t->readfrompipe,t->writetopipe);
			return;
		}
		return;
	}	
	if (t->localparsestate == LOCALPARSE_READINGERROR) {
		gui_controlnotebook_Msg(&t->ct,"WeIRCd failed to startup due to an <b>unknown error while loading/parsing the configuration</b> file.\n\nThe most frequent reason for this is that you use a manually modified config file that contains mistakes. You need to fix them before continuing.",MSGTYPE_ERROR);
		if (stringisinstring(copy,"UNKNOWN CONFIG VERSION") >= 0) {
			gui_controlnotebook_Msg(&t->ct,"WeIRCd failed to startup due to an <b>unknown config file version</b>.\n\nYou seem to be using a config file from a <i>newer</i> WeIRCd version. This doesn't work.\n\nTo continue, download an example config file and replace the current one with it.",MSGTYPE_ERROR);
			//do something to update config (parse and save)
		}
		if (stringisinstring(copy,"Do never use the default password") >= 0) {
			gui_controlnotebook_Msg(&t->ct,"One of your admin accounts still has the <b>default password</b>. You should change it (seriously).",MSGTYPE_ERROR);
		}
		t->havepipes = 0;
		localinstall_ClosePipes(t->readfrompipe,t->writetopipe);
		return;
	}
}
void mainwindow_ParsePipeBuf(const char* buf, void* tptr) {
	const char* s = buf;
	struct tab* t = linkedlist_GetData(tptr);
	if (s != NULL) {
		stradd(t->buf,s,TABRECVBUF-1);
		while (charpos(t->buf,'\n') >= 0) {
			mainwindow_ParsePipeLine(t->buf,tptr);
			if (t->havepipes == 0) {return;}
			cut(t->buf,charpos(t->buf,'\n')+1);
		}
	}
}
gboolean mainwindow_CheckLocalPipe(gpointer data) {
	void* item = tablist;
	while (item != NULL) {
		struct tab* t = linkedlist_GetData(item);
		if (t->remote == 0 && t->running > 0 && t->havepipes == 1) {
			localinstall_CheckPipe(t->readfrompipe,mainwindow_ParsePipeBuf,item);
			/*i
			}*/
		}
		item = linkedlist_NextItem(item);
	}
	return TRUE;
}
gboolean mainwindow_CheckStats(gpointer data) {
	void* item;
	if (localinstall_ReadStatus() < 0) {
		item = tablist;
		while (item != NULL) {
			struct tab* t = linkedlist_GetData(item);
			if (t->remote == 0) {
				gtk_entry_set_text(GTK_ENTRY(t->ct.users_local),"0");
				gtk_widget_set_sensitive(t->ct.users_local,FALSE);
				gtk_entry_set_text(GTK_ENTRY(t->ct.users_global),"0");
				gtk_widget_set_sensitive(t->ct.users_global,FALSE);
				gtk_entry_set_text(GTK_ENTRY(t->ct.opers),"0");
				gtk_widget_set_sensitive(t->ct.opers,FALSE);
			}
			item = linkedlist_NextItem(item);
		}
		return;
	}
	item = tablist;
	while (item != NULL) {
		struct tab* t = linkedlist_GetData(item);
		if (t->remote == 0) {
			if (t->running == 1) {
				char str[10];
				snprintf(str,9,"%d",status_currentlocalusers);
				gtk_entry_set_text(GTK_ENTRY(t->ct.users_local),str);
				gtk_widget_set_sensitive(t->ct.users_local,TRUE);
				snprintf(str,9,"%d",status_currentglobalusers);
				gtk_entry_set_text(GTK_ENTRY(t->ct.users_global),str);
				gtk_widget_set_sensitive(t->ct.users_global,TRUE);
				snprintf(str,9,"%d",status_opers);
				gtk_entry_set_text(GTK_ENTRY(t->ct.opers),str);
				gtk_widget_set_sensitive(t->ct.opers,TRUE);
			}else{
				gtk_entry_set_text(GTK_ENTRY(t->ct.users_local),"0");
				gtk_widget_set_sensitive(t->ct.users_local,FALSE);
				gtk_entry_set_text(GTK_ENTRY(t->ct.users_global),"0");
				gtk_widget_set_sensitive(t->ct.users_global,FALSE);
				gtk_entry_set_text(GTK_ENTRY(t->ct.opers),"0");
				gtk_widget_set_sensitive(t->ct.opers,FALSE);
			}
		}
		item = linkedlist_NextItem(item);
	}
	return TRUE;
}
gboolean mainwindow_CheckLocalRunningState(gpointer data) {
	void* ctab = gui_GetCurrentTab();
	int runningstate = localinstall_IsServerRunning(&localpid);
	if (runningstate == 0) {
		void* item = tablist;
		while (item != NULL) {
			struct tab* t = linkedlist_GetData(item);
			if (t->remote == 0 && t->running == 0) {
				if (t->localparsestate == LOCALPARSE_NOWRUNNING || t->havepipes == 0) {
					t->running = 1;
					gui_controlbook_Value(t->ct.value_status,"Running",0);
				}else{
					t->running = 2;localpid = -1;
					gui_controlbook_Value(t->ct.value_status,"Starting...",0);
				}
				if (item == ctab) {
					gui_AdjustButtonsToTab(item);
				}
				gui_TabButtons(item);
			}
			if (t->remote == 0 && t->running == 1) {
				if (t->localparsestate != LOCALPARSE_NOWRUNNING && t->havepipes == 1) {
					t->running = 2;localpid = -1;
					gui_controlbook_Value(t->ct.value_status,"Starting...",0);
					if (item == ctab) {
						gui_AdjustButtonsToTab(item);
					}
					gui_TabButtons(item);
				}
			}
			if (t->remote == 0 && t->running == 2) {
				if (t->localparsestate == LOCALPARSE_NOWRUNNING || t->havepipes == 0) {
					t->running = 1;
					gui_controlbook_Value(t->ct.value_status,"Running",0);
					if (item == ctab) {
						gui_AdjustButtonsToTab(item);
					}	
					gui_TabButtons(item);
				}
			}
			item = linkedlist_NextItem(item);
		}
	}else{
		int wantrestart = 0;
		void* item;
		/* check if any tab still has pipes from startup */
		item = tablist;
		while (item != NULL) {
			struct tab* t = linkedlist_GetData(item);
			if (t->remote == 0 && t->running == 2) {
				if (t->havepipes == 1) { //we are still piped. don't quit them.
					return;
				}
			}
			item = linkedlist_NextItem(item);
		}
		/* check if any tab scheduled a restart */
		item = tablist;
		while (item != NULL) {
			struct tab* t = linkedlist_GetData(item);
			if (t->remote == 0 && t->restartscheduled == 1) {
				t->restartscheduled = 0;
				wantrestart = 1;
			}
			item = linkedlist_NextItem(item);
		}
		if (wantrestart == 1) {
			mainwindow_localserver_start();
		}
		/* set all tabs to disconnect */
		item = tablist;
		while (item != NULL) {
			struct tab* t = linkedlist_GetData(item);
			if (t->remote == 0 && t->running > 0) {
				t->wanttostop = 0;
				t->restartscheduled = wantrestart; //have start button deactivated
				if (t->havepipes == 1) {
					t->havepipes = 0;
					localinstall_ClosePipes(t->readfrompipe,t->writetopipe);
				}
				t->running = 0;localpid = -1;
				gui_controlbook_Value(t->ct.value_status,"Stopped",0);
				if (item == ctab) {
					gui_AdjustButtonsToTab(item);
				}
				gui_TabButtons(item);
				t->restartscheduled = 0; //do not keep restart scheduled
			}
			item = linkedlist_NextItem(item);
		}
	}
	return TRUE;
}

static void gevent_mainwindow_newtab( GtkMenuItem *widget,
                     gpointer   data ) {
	printf("WUT\n");
	gui_AddEmptyTab();
}
static gint do_popup_menu (GtkWidget *my_widget, GdkEventButton *event) {
	GtkWidget *menu;
	if (!event) {return;}
	menu = gtk_menu_new ();
	g_signal_connect (menu, "deactivate", 
			G_CALLBACK (gtk_widget_destroy), NULL);
	if (event->button != 3 || event->type != GDK_BUTTON_PRESS) {
		return FALSE;
	}
	/*if (event) {
		button = event->button;
		event_time = event->time;
	}else{
		button = 0;
		event_time = gtk_get_current_event_time();
	}*/
	gtk_widget_show(menu);
	gtk_menu_attach_to_widget (GTK_MENU (menu), my_widget, NULL);
	//GtkWidget* item1 = gtk_menu_item_new_with_label("New tab");gtk_widget_show(item1);
	GtkWidget* item1 = imgmitem("_New tab", GTK_STOCK_NEW);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),item1);
	g_signal_connect(G_OBJECT(item1), "activate", G_CALLBACK(gevent_mainwindow_newtab),
				 NULL);
	GtkWidget* sep = gtk_separator_menu_item_new();
	gtk_widget_show(sep);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),sep);
	GtkWidget* item2 = imgmitem("_Close tab", GTK_STOCK_CLOSE);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),item2);
	gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, NULL, 
                  event->button, event->time);
	return TRUE;
}
GtkWidget* passwdlg = NULL;
GtkWidget* passwdlgkeyimage = NULL;
char passwdlg_accname[50];
int passwdlg_isdefaultpass;
int passwdlg_runserver = 0;
struct controlnotebook* passwdlg_notebook;
GtkWidget* passwentry;

int allowpwdestruction = 0;

void passwchanged(GtkWidget *w, gpointer user_data) {
	GtkWidget* b = (GtkWidget*)user_data;
	const char* p = gtk_entry_get_text(GTK_ENTRY(passwentry));
	if (strlen(p) >= 4) {
		gtk_widget_set_sensitive(b, TRUE);
	}else{
		gtk_widget_set_sensitive(b, FALSE);
	}
}
static gint passwconfirm(GtkWidget *my_widget, GdkEventButton *event) {
	allowpwdestruction = 1;
	const char* p = gtk_entry_get_text(GTK_ENTRY(passwentry));
	char val[200];
	snprintf(val,199,"ircops#%s#password",passwdlg_accname);
	value_set(val,p);
	if (gui_UpdateTabConfig(passwdlg_notebook->parenttab) != 0) {
		GtkWidget* dlg = gtk_message_dialog_new(NULL,0,
		GTK_MESSAGE_ERROR,
		GTK_BUTTONS_OK,
		"Failed to update configuration",NULL);
		gtk_window_set_title(GTK_WINDOW(dlg),"Fatal error");
		gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER);
		gtk_widget_show(dlg);
		return;
	}
	int i = passwdlg_runserver;passwdlg_runserver = 0;
	gtk_widget_destroy(passwdlg);
	if (i == 1) {
		i = 0;
		mainwindowaction_StartServer();
	}
	return TRUE;
}
static gint passwcancel(GtkWidget *my_widget, GdkEventButton *event) {
	passwdlg_runserver = 0;
	gtk_widget_destroy(passwdlg);
	return TRUE;
}

static void gevent_passwdlg_destroy(GtkWidget *widget, gpointer data);
void mainwindowaction_passwdlg_Show(const char* accname, int isdefaultpass, struct controlnotebook* c) {
	passwdlg_notebook = c;
	strcopy(passwdlg_accname,accname,49);
	passwdlg_isdefaultpass = isdefaultpass;
	if (isdefaultpass == 1) {
		allowpwdestruction = 0;
	}else{
		allowpwdestruction = 1;
	}
	if (passwdlg) {gtk_widget_show(passwdlg);return;}
	if (!passwdlgkeyimage) {
		gui_splash_createpicdir();
		char picpath[500];
		snprintf(picpath,499,"%spwkey.png",picdir);
		passwdlgkeyimage = gtk_image_new_from_file(picpath);
		gtk_widget_show(passwdlgkeyimage);
	}
	
	passwdlg = gtk_window_new (GTK_WINDOW_TOPLEVEL);g_object_ref(passwdlg);
	//gtk_widget_set_size_request(aboutdlg,450,-1);
	gtk_container_set_border_width(GTK_CONTAINER(passwdlg), 4);
	gtk_window_set_position(GTK_WINDOW(passwdlg), GTK_WIN_POS_CENTER);
	gtk_window_set_title(GTK_WINDOW(passwdlg), "Enter New Password");
	gtk_window_set_modal(GTK_WINDOW(passwdlg), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(passwdlg),GTK_WINDOW(mainwindow));
				
	gtk_window_set_resizable(GTK_WINDOW(passwdlg),FALSE);
	gtk_window_set_icon(GTK_WINDOW(passwdlg), applogo);
	GtkWidget* hbox = gtk_hbox_new(FALSE, 4);gtk_widget_show(hbox);
	gtk_container_add(GTK_CONTAINER(passwdlg), hbox);
	
	/* now use our precious img here */
	gtk_box_pack_start(GTK_BOX(hbox), passwdlgkeyimage, FALSE, FALSE, 4);
	
	GtkWidget* vbox = gtk_vbox_new(FALSE,0);gtk_widget_show(vbox);
	gtk_box_pack_start(GTK_BOX(hbox), vbox, TRUE, TRUE, 2);
	
	//GtkWidget* align = gtk_alignment_new(0,0,1,1);gtk_widget_show(align);
	//gtk_box_pack_start(GTK_BOX(vbox), align, FALSE, FALSE, 0);
	
	char str[500];
	if (isdefaultpass == 1) {
		snprintf(str,499,
"<span font=\"sans\">The IRC admin account <i>\"%s\"</i> doesn't have a proper password yet. Please <b>enter a password</b> for that administrator account now:</span>",accname);
	}else{
		snprintf(str,499,
"<span font=\"sans\">Enter a <b>new password</b> for the IRC admin account <big><i>\"%s\"</i></big>:</span>",accname);
	}
	GtkWidget* txtlbl = gtk_label_new(str);
	gtk_label_set_use_markup(GTK_LABEL(txtlbl),TRUE);
	//gtk_widget_set_size_request(txtlbl,446,-1);
	gtk_widget_show(txtlbl);
	gtk_label_set_line_wrap(GTK_LABEL(txtlbl),TRUE);
	//gtk_container_add(GTK_CONTAINER(align),txtlbl);
	gtk_box_pack_start(GTK_BOX(vbox), txtlbl, FALSE, FALSE, 0);
	
	/* pack entry */
	GtkWidget* ventry = gtk_entry_new();
	gtk_entry_set_visibility(GTK_ENTRY(ventry), FALSE);gtk_widget_show(ventry);
	gtk_box_pack_start(GTK_BOX(vbox), ventry, FALSE, FALSE, 2);
	
	/* make nice buttons and pack them aswell */
	GtkWidget* cancel = gtk_button_new_with_label("Cancel");gtk_widget_show(cancel);
	GtkWidget* ok = gtk_button_new_with_label("Confirm New Password");gtk_widget_show(ok);
	GtkWidget* newhbox = gtk_hbox_new(FALSE,0);gtk_widget_show(newhbox);
	gtk_box_pack_end(GTK_BOX(newhbox), ok, FALSE, FALSE, 0);
	gtk_box_pack_end(GTK_BOX(newhbox), cancel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), newhbox, TRUE, TRUE, 0);
	if (isdefaultpass == 1) {
		gtk_widget_set_sensitive(cancel, FALSE);
	}
	gtk_widget_set_sensitive(ok, FALSE);
	passwentry = ventry;
	g_signal_connect (ok, "button-press-event", 
			G_CALLBACK (passwconfirm), NULL);
	g_signal_connect (ok, "button-press-event", 
			G_CALLBACK (passwcancel), NULL);
	
	/* gtk text entry signal */
	g_signal_connect (ventry, "changed", 
			G_CALLBACK (passwchanged), ok);
	
	//g_signal_connect (G_OBJECT (aboutdlg), "response",
	//	      G_CALLBACK (aboutresponse), NULL);
	g_signal_connect (G_OBJECT (passwdlg), "destroy",
		      G_CALLBACK (gevent_passwdlg_destroy), NULL);
	gtk_widget_show(passwdlg);
}
static void gevent_passwdlg_destroy(GtkWidget *widget, gpointer data) {
	passwdlg = NULL;
	passwdlgkeyimage = NULL;
	if (allowpwdestruction != 1) {
		mainwindowaction_passwdlg_Show(passwdlg_accname,passwdlg_isdefaultpass,passwdlg_notebook);
	}else{
		passwdlg_runserver = 0;
	}
}
void mainwindowaction_StartServerWithValueCheck() {
	value_startcycle();
	char* name;char* value;
	while (value_cyclenameandvalue(&name,&value) == 0) {
		//printf(" %s -> %s\n",name,value);
		if (strstw(name,"ircops#") == 0 && strendswith(name,"#password") == 0) {
			if (strcasecmp(value,"xxxx") == 0) {
				char accountname[50];
				strcopy(accountname,name,49);
				if (charpos(accountname,'#') >= 0) {cut(accountname,charpos(accountname,'#')+1);}
				if (charpos(accountname,'#') >= 0) {accountname[charpos(accountname,'#')] = 0;}
				char* t = gui_GetCurrentTab();
				struct tab* ctab = linkedlist_GetData(t);
				passwdlg_runserver = 1;
				mainwindowaction_passwdlg_Show(accountname,1,&ctab->ct);
				return;
			}
		}
	}
	mainwindowaction_StartServer();
}
static void gevent_mainwindow_start( GtkWidget *widget,
                     gpointer   data ) {
	mainwindowaction_StartServerWithValueCheck();
}
static void gevent_mainwindow_restart( GtkWidget *widget,
                     gpointer   data ) {
	mainwindow_dlg_AskRestartServer();
}
static void gevent_mainwindow_stop( GtkWidget *widget,
                     gpointer   data ) {
	mainwindow_dlg_AskStopServer();
}
static void gevent_mainwindow_rehash( GtkWidget *widget,
                     gpointer   data ) {
	printf("rehash now\n");
	mainwindowaction_RehashServer();
}
static void gevent_mainwindow_checkforupdate( GtkWidget *widget,
                     gpointer   data ) {
	char* t = gui_GetCurrentTab();
	struct tab* ctab = linkedlist_GetData(t);
	char* p = ctab->versionstr;
	if (p == NULL) {return;}
	char sendstr[300];
	snprintf(sendstr,299,"http://eloxoph.com/weircd/check?v=%s",p);
	urls_OpenUrl(sendstr);
}
gint delete_event( GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   data ) {
	return FALSE;
}
void aboutlinkfunc(GtkAboutDialog *about, const gchar *link_, gpointer data) {
	printf("LINK: %s\n",link_);
}
void aboutemailfunc(GtkAboutDialog *about, const gchar *link_, gpointer data) {
	printf("EMAIL: %s\n",link_);
}
void weircdhpclick(GtkButton *button, gpointer user_data) {
	urls_OpenUrl("http://eloxoph.com/weircd/");
}
void weircddocsclick(GtkButton *button, gpointer user_data) {
	urls_OpenUrl("http://eloxoph.com/weircd/docs");
}
void eprojectsclick(GtkButton *button, gpointer user_data) {
	urls_OpenUrl("http://eloxoph.com/projects");
}

GtkWidget* aboutdlg = NULL;
static void gevent_aboutdlg_destroy( GtkWidget *widget,
                     gpointer   data ) {
	aboutdlg = NULL;
}

void gevent_mainwindow_about(GtkMenuItem *menuitem, gpointer user_data) {
	if (aboutdlg) {gtk_widget_show(aboutdlg);return;}
	
	aboutdlg = gtk_window_new (GTK_WINDOW_TOPLEVEL);g_object_ref(aboutdlg);
	//gtk_widget_set_size_request(aboutdlg,450,-1);
	gtk_container_set_border_width(GTK_CONTAINER(aboutdlg), 4);
	gtk_window_set_position(GTK_WINDOW(aboutdlg), GTK_WIN_POS_CENTER);
	gtk_window_set_title(GTK_WINDOW(aboutdlg), "About Administration Tool");
	gtk_window_set_transient_for(GTK_WINDOW(aboutdlg),GTK_WINDOW(mainwindow));
	
	gtk_window_set_resizable(GTK_WINDOW(aboutdlg),FALSE);
	gtk_window_set_icon(GTK_WINDOW(aboutdlg), applogo);
	GtkWidget* vbox = gtk_vbox_new(FALSE,0);gtk_widget_show(vbox);
	gtk_container_add(GTK_CONTAINER(aboutdlg), vbox);
	
	GtkWidget* hbox = gtk_hbox_new(FALSE,0);gtk_widget_show(hbox);
	
	GtkWidget* titlelabel = gtk_label_new("<span font=\"Sans 14\" font_weight=\"heavy\">WeIRCd Admin Tool</span>");gtk_widget_show(titlelabel);
	gtk_label_set_use_markup(GTK_LABEL(titlelabel),TRUE);
	GtkWidget* versionlabel = gtk_label_new("<span font=\"Sans 10\">v1.2 Build 25</span>");gtk_widget_show(versionlabel);
	gtk_label_set_use_markup(GTK_LABEL(versionlabel),TRUE);
	gtk_box_pack_start(GTK_BOX(vbox),titlelabel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox),versionlabel, FALSE, FALSE, 0);
	GtkWidget* align = gtk_alignment_new(0,0,1,1);gtk_widget_show(align);
	gtk_box_pack_start(GTK_BOX(vbox), align, FALSE, FALSE, 0);
	GtkWidget* copyrightlabel = gtk_label_new( 
"<span font=\"Sans 8\" color=\"black\">"
"Copyright © 2009-2010 by Jonas Thiem\n"
"This software is GPL-licensed. You may obtain its source at http://eloxoph.com/weircd/releases/\n\n"
"WeIRCd © 2007-2010 by Jonas Thiem\n"
"WeIRCd is GPL-licensed. You may obtain its source at http://eloxoph.com/weircd/releases/\n\n"
"Icon set taken from http://damieng.com/creative/icons/silk-companion-1-icons\n"
"See site for Copyright owner and licensing details\n\n"
"Splash image taken from\nhttp://www.movingtofreedom.org/2008/09/27/crossing-afton-state-park-mn/\n"
"(Creative Commons, see site for licensing details)\n\n"
"This software is based in part on the work of the Independent JPEG Group (linked to libjpeg and comes with precompiled libjpeg dll)\n\n"
"fontconfig Copyright © 2001,2003 Keith Packard\n\n"
"Expat Copyright (c) 1998, 1999, 2000 Thai Open Source Software Center Ltd and Clark Cooper\n"
"Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006 Expat maintainers.\n\n"
"This software ships binary distributions of GPL-licensed libraries. You may obtain the source at "
"http://eloxoph.com/weircd/releases/GTK+-sources-0.zip"
"</span>"
);
	gtk_label_set_use_markup(GTK_LABEL(copyrightlabel),TRUE);
	gtk_widget_set_size_request(copyrightlabel,446,-1);
	gtk_widget_show(copyrightlabel);
	gtk_label_set_line_wrap(GTK_LABEL(copyrightlabel),TRUE);
	gtk_container_add(GTK_CONTAINER(align),copyrightlabel);
	//g_signal_connect (G_OBJECT (aboutdlg), "response",
	//	      G_CALLBACK (aboutresponse), NULL);
	g_signal_connect (G_OBJECT (aboutdlg), "destroy",
		      G_CALLBACK (gevent_aboutdlg_destroy), NULL);
	gtk_widget_show(aboutdlg);
}


void gui_mainwindow_Show() {
	GtkWidget* i;
	if (mainwindow == NULL) {
		//construct main window
		mainwindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
		gtk_window_set_position(GTK_WINDOW(mainwindow), GTK_WIN_POS_CENTER);
		//gtk_window_set_default_size (GTK_WINDOW(mainwindow), 600, 350);
		gtk_window_set_title(GTK_WINDOW(mainwindow), "WeIRCd Administration Tool");
		gtk_window_set_resizable(GTK_WINDOW(mainwindow),FALSE);
		gtk_window_set_icon(GTK_WINDOW(mainwindow), applogo);
		gtk_signal_connect (GTK_OBJECT (mainwindow), "delete_event",
                        GTK_SIGNAL_FUNC (delete_event), NULL);

		g_signal_connect (G_OBJECT (mainwindow), "destroy",
		      G_CALLBACK (gevent_mainwindow_destroy), NULL);
		      
		//menubar & menubar vbox
		vbox_menubar_content = gtk_vbox_new(FALSE,0);gtk_widget_show(vbox_menubar_content);
		menubar = gtk_menu_bar_new();gtk_widget_show(menubar);
		gtk_box_pack_start(GTK_BOX(vbox_menubar_content), menubar, FALSE, FALSE, 0);
		//top right logo
		/*GtkWidget* logoalign = gtk_alignment_new(1,0.5,0,0);gtk_widget_show(logoalign);
		GtkWidget* i = gtk_image_new_from_file(gui_splash_toprightlogo());gtk_widget_show(i);
		gtk_box_pack_start(GTK_BOX(vbox_menubar_content), logoalign, FALSE, FALSE, 0);
		gtk_container_add(GTK_CONTAINER(logoalign), i);*/
		//menubar items
		// admintool (connect to other weircd instance, disconnect, quit)
		menu_admintool = gtk_menu_item_new_with_mnemonic("_Admin Tool");
		gtk_widget_show(menu_admintool);
		gtk_menu_shell_append(GTK_MENU_SHELL(menubar),menu_admintool);
			//admintool menu
			adminmenu = gtk_menu_new();gtk_widget_show(adminmenu);
			gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_admintool),adminmenu);
			// connect
			adminm_connect = imgmitem("_Connect to WeIRCd instance...", GTK_STOCK_NETWORK);
			gtk_menu_shell_append(GTK_MENU_SHELL(adminmenu),adminm_connect);
			g_signal_connect (G_OBJECT (adminm_connect), "activate",
				G_CALLBACK (gevent_mainwindow_connecttoinstance), NULL);
			// sep
			adminm_sep = gtk_separator_menu_item_new();
			gtk_widget_show(adminm_sep);
			gtk_menu_shell_append(GTK_MENU_SHELL(adminmenu),adminm_sep);
			// quit
			/*adminm_preferences = imgmitem("Admin Tool _settings", GTK_STOCK_PREFERENCES);
			gtk_menu_shell_append(GTK_MENU_SHELL(adminmenu),adminm_preferences);
			// sep (2)
			adminm_sep2 = gtk_separator_menu_item_new();
			gtk_widget_show(adminm_sep2);
			gtk_menu_shell_append(GTK_MENU_SHELL(adminmenu),adminm_sep2);*/
			// terminate
			adminm_quit = imgmitem("_Quit WeIRCd Admin Tool", GTK_STOCK_QUIT);
			gtk_menu_shell_append(GTK_MENU_SHELL(adminmenu),adminm_quit);
			
			gtk_signal_connect_object (GTK_OBJECT(adminm_quit), "activate",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (mainwindow));
		// currentconnection (disconnect admin connection)
		menu_currentconnection = gtk_menu_item_new_with_mnemonic("Current Server Co_nnection");
		gtk_widget_show(menu_currentconnection);
		gtk_menu_shell_append(GTK_MENU_SHELL(menubar),menu_currentconnection);
			//connection menu
			connectionmenu = gtk_menu_new();gtk_widget_show(connectionmenu);
			gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_currentconnection),connectionmenu);
			// connect
			connm_connect = imgmitem("_Connect", GTK_STOCK_CONNECT);
			gtk_menu_shell_append(GTK_MENU_SHELL(connectionmenu),connm_connect);
			// disconnect
			connm_disconnect = imgmitem("_Disconnect", GTK_STOCK_DISCONNECT);
			gtk_menu_shell_append(GTK_MENU_SHELL(connectionmenu),connm_disconnect);
			// seperator
			connm_sep = gtk_separator_menu_item_new();
			gtk_widget_show(connm_sep);
			gtk_menu_shell_append(GTK_MENU_SHELL(connectionmenu),connm_sep);
			// reconnect
			connm_reconnect = imgmitem("_Reconnect", GTK_STOCK_REFRESH);
			gtk_menu_shell_append(GTK_MENU_SHELL(connectionmenu),connm_reconnect);
			// seperator (2)
			connm_sep2 = gtk_separator_menu_item_new();
			gtk_widget_show(connm_sep2);
			gtk_menu_shell_append(GTK_MENU_SHELL(connectionmenu),connm_sep2);
			// close tab
			connm_closetab = imgmitem("Close server _tab", GTK_STOCK_CLOSE);
			gtk_menu_shell_append(GTK_MENU_SHELL(connectionmenu),connm_closetab);
		// servercontrol (start server, stop server)
		menu_servercontrol = gtk_menu_item_new_with_mnemonic("Server _Control");
		gtk_widget_show(menu_servercontrol);
		gtk_menu_shell_append(GTK_MENU_SHELL(menubar),menu_servercontrol);
			//control menu
			controlmenu = gtk_menu_new();gtk_widget_show(controlmenu);
			gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_servercontrol),controlmenu);
			// start
			control_start = imgmitem("St_art", GTK_STOCK_MEDIA_PLAY);
			gtk_menu_shell_append(GTK_MENU_SHELL(controlmenu),control_start);
			g_signal_connect (G_OBJECT (control_start), "activate",
				G_CALLBACK (gevent_mainwindow_start), NULL);
			// restart
			control_restart = imgmitem("_Restart",GTK_STOCK_REFRESH);
			gtk_menu_shell_append(GTK_MENU_SHELL(controlmenu),control_restart);
			g_signal_connect (G_OBJECT (control_restart), "activate",
				G_CALLBACK (gevent_mainwindow_restart), NULL);
			// stop
			control_stop = imgmitem("_Stop", GTK_STOCK_STOP);
			gtk_menu_shell_append(GTK_MENU_SHELL(controlmenu),control_stop);
			g_signal_connect (G_OBJECT (control_stop), "activate",
				G_CALLBACK (gevent_mainwindow_stop), NULL);
			// seperator
			control_sep = gtk_separator_menu_item_new();
			gtk_widget_show(control_sep);
			gtk_menu_shell_append(GTK_MENU_SHELL(controlmenu),control_sep);
			// reloadconfig
			control_reloadconfig = imgmitem("Reload _configuration", GTK_STOCK_REDO);
			gtk_menu_shell_append(GTK_MENU_SHELL(controlmenu),control_reloadconfig);
			g_signal_connect (G_OBJECT (control_reloadconfig), "activate",
				G_CALLBACK (gevent_mainwindow_rehash), NULL);
			// update check
			control_checkforupdate = imgmitem("Check for _updates", GTK_STOCK_FIND);
			gtk_menu_shell_append(GTK_MENU_SHELL(controlmenu),control_checkforupdate);
			g_signal_connect (G_OBJECT (control_checkforupdate), "activate",
				G_CALLBACK (gevent_mainwindow_checkforupdate), NULL);
			// seperator (2)
			control_sep2 = gtk_separator_menu_item_new();
			gtk_widget_show(control_sep2);
			gtk_menu_shell_append(GTK_MENU_SHELL(controlmenu),control_sep2);
			// server linking
			control_serverlinking = imgmitem("Server linking...", GTK_STOCK_NETWORK);
			gtk_menu_shell_append(GTK_MENU_SHELL(controlmenu),control_serverlinking);
		/*// settings (admin tool settings)
		menu_settings = gtk_menu_item_new_with_mnemonic("_Settings");
		gtk_widget_show(menu_settings);
		gtk_menu_shell_append(GTK_MENU_SHELL(menubar),menu_settings);
			//settings menu
			settingsmenu = gtk_menu_new();gtk_widget_show(settingsmenu);
			gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_settings),settingsmenu);
			// open preferences
			settings_settings = imgmitem("Admin tool preferences...", GTK_STOCK_PREFERENCES);
			gtk_menu_shell_append(GTK_MENU_SHELL(settingsmenu),settings_settings);*/
		// help (help, about)
		menu_help = gtk_menu_item_new_with_mnemonic("_About");
		gtk_widget_show(menu_help);
		gtk_menu_shell_append(GTK_MENU_SHELL(menubar),menu_help);
			//help menu
			helpmenu = gtk_menu_new();gtk_widget_show(helpmenu);
			gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_help),helpmenu);
			// open weircd homepage
			help_whp = imgmitem("WeIRCd homepage (web)", GTK_STOCK_INDEX);
			gtk_menu_shell_append(GTK_MENU_SHELL(helpmenu),help_whp);
			g_signal_connect (G_OBJECT (help_whp), "activate",
			G_CALLBACK (weircdhpclick), NULL);
			// open weircd web docs
			help_wdocs = imgmitem("WeIRCd User docs (web)", GTK_STOCK_HELP);
			gtk_menu_shell_append(GTK_MENU_SHELL(helpmenu),help_wdocs);
			g_signal_connect (G_OBJECT (help_wdocs), "activate",
			G_CALLBACK (weircddocsclick), NULL);
			// open eloxoph projects site
			help_eprojects = imgmitem("Other projects of Eloxoph... (web)", GTK_STOCK_INFO);
			gtk_menu_shell_append(GTK_MENU_SHELL(helpmenu),help_eprojects);
			g_signal_connect (G_OBJECT (help_eprojects), "activate",
			G_CALLBACK (eprojectsclick), NULL);
			// seperator
			help_sep = gtk_separator_menu_item_new();
			gtk_widget_show(help_sep);
			gtk_menu_shell_append(GTK_MENU_SHELL(helpmenu),help_sep);
			// open about dialog
			help_about = imgmitem("About WeIRCd Admin Tool...", GTK_STOCK_ABOUT);
			gtk_menu_shell_append(GTK_MENU_SHELL(helpmenu),help_about);
			g_signal_connect(G_OBJECT(help_about), "activate", G_CALLBACK(gevent_mainwindow_about),
				 NULL);
		tabs = gtk_notebook_new();
		gtk_box_pack_end(GTK_BOX(vbox_menubar_content), tabs, TRUE, TRUE, 0);
		//gtk_widget_set_size_request(tabs,-1,200);
		gtk_widget_show(tabs);
		//add main vbox to window
		gtk_container_add(GTK_CONTAINER(mainwindow),vbox_menubar_content);
	}
	
}
void gui_mainwindow_menus_Connected(int remote) {
	gtk_widget_set_sensitive(connm_connect, FALSE);
	if (remote == 1) {
		gtk_widget_set_sensitive(connm_disconnect, TRUE);
		gtk_widget_set_sensitive(connm_reconnect, TRUE);
	}else{
		gtk_widget_set_sensitive(connm_disconnect, FALSE);
		gtk_widget_set_sensitive(connm_reconnect, FALSE);
	}
	gtk_widget_set_sensitive(control_start, FALSE);
	gtk_widget_set_sensitive(control_restart, FALSE);
	gtk_widget_set_sensitive(control_stop, FALSE);
	gtk_widget_set_sensitive(control_reloadconfig, FALSE);
	gtk_widget_set_sensitive(control_checkforupdate, TRUE);
	gtk_widget_set_sensitive(control_serverlinking, FALSE);
	gtk_widget_set_sensitive(connm_closetab, TRUE);
}
static void disconnectedbuttons() {
	gtk_widget_set_sensitive(connm_connect, TRUE);
	gtk_widget_set_sensitive(connm_disconnect, FALSE);
	gtk_widget_set_sensitive(connm_reconnect, FALSE);
	gtk_widget_set_sensitive(control_start, FALSE);
	gtk_widget_set_sensitive(control_restart, FALSE);
	gtk_widget_set_sensitive(control_stop, FALSE);
	gtk_widget_set_sensitive(control_reloadconfig, FALSE);
	gtk_widget_set_sensitive(control_checkforupdate, FALSE);
	gtk_widget_set_sensitive(control_serverlinking, FALSE);
}
void gui_mainwindow_menus_Disconnected() {
	disconnectedbuttons();
	gtk_widget_set_sensitive(connm_closetab, TRUE);
}
void gui_mainwindow_menus_NoContext() {
	disconnectedbuttons();
	gtk_widget_set_sensitive(connm_connect, FALSE);
}
int gui_mainwindow_Quit() {
	if (gui_wantquit == 1) {return 0;}
	return -1;
}