//    WeIRCd administration tool
//    Copyright (C) 2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "admintool.h"

#define PROCESSLENGTH 2000
#ifndef WIN
void strlwr(char *s) {
	while (*s) {
		*s = tolower(*s);
		s++;
	}
}
#endif
void strupper(char *s) {
	while (*s) {
		*s = toupper(*s);
		s++;
	}
}
int isnumber(const char* s) {
	if (strlen(s) <= 0) {return -1;}
	unsigned int r = 0;
	while (r < strlen(s)) {
		if (s[r] < '0' || s[r] > '9') {return -1;}
		r++;
	}
	return 0;
}
int stringisinstring(const char* longstring, const char* shortstring) {
	char* copy1 = alloca(strlen(longstring)+1);strcpy(copy1,longstring);strlwr(copy1);
	char* copy2 = alloca(strlen(shortstring)+1);strcpy(copy2,shortstring);strlwr(copy2);
	void* b = strstr(copy1,copy2);
	if (b != NULL) {
		return b-(void*)copy1;
	}else{
		return -1;
	}
}
void stradd(char* dest, const char* src, int len) {
	int addlen = len;
	addlen -= strlen(dest);
	strncat(dest,src,addlen);
}
void strcopy(char* dest, const char* src, int len) {
	strncpy(dest,src,len);dest[len] = 0;
}
int charpos(const char* stringle, char letter) {
	unsigned int z;
	z = 0;
	if (strlen(stringle) > 0) {
		while (z < strlen(stringle)) {
			if (stringle[z] == 0) {
				return -1;
			}
			if (stringle[z] == letter) {
				return z;
			}
			z += 1;
		}
		return -1;
	}else{
		return -1;
	}
}
int charposfromright(const char* stringle, char letter) {
	unsigned int z;
	z = strlen(stringle);
	if (strlen(stringle) > 0) {
		while (z > 0) {
			z -= 1;
			if (stringle[z] == letter) {
				return z;
			}
		}
		return -1;
	}else{return -1;}
}
void cut(char* str, int count) {
	if (count <= 0) {return;}
	int r = strlen(str);
	if (count >= r) {strcpy(str,"");return;}
	memmove(str, str+count, r+1);
}
int casecomparechars(char c1, char c2) {
	/* Check if one char equals another (case insensitive for ascii a-z A-Z letters) */
	if (c1 == c2) {return 0;}
	if ((c1 >= 'A' && c1 <= 'Z') || (c1 >= 'a' && c1 <= 'z')) {
		if ((c2 >= 'a' && c2 <= 'z') || (c2 >= 'A' && c2 <= 'Z')) {
			if (c2 >= 'A' && c2 <= 'Z') {c2 += 'a'-'A';}
			if (c1 >= 'A' && c1 <= 'Z') {c1 += 'a'-'A';}
			if (c1 == c2) {return 0;}
		}
	}
	return -1;
}
int strcasecmplen(const char* str1, const char* str2, unsigned int len) {
	unsigned int r = 0;
	while (r < len && r < strlen(str1) && r < strlen(str2)) {
		if (casecomparechars(str1[r],str2[r]) != 0) {
			return -1;
		}
		r++;
	}
	return 0;
}
int strstw(const char* bigstring,const char* startstring) {
	/* Checks if bigstring is starting with the contents of startstring. Returns 0 if that's the case,
	   otherwise -1. */
	if (strlen(bigstring) <= 0) {
		if (strlen(startstring) > 0) {
			return -1;
		}else{return 0;}
	}
	if (strlen(startstring) <= 0) {return 0;}
	if (strlen(bigstring) < strlen(startstring)) {
		return -1;
	}
	if (strlen(bigstring) > strlen(startstring)) {
		if (strcasecmplen(bigstring,startstring,strlen(startstring)) == 0) {
			return 0;
		}
		return -1;
	}else{
		if (strcasecmp(bigstring,startstring) == 0) {return 0;}
		return -1;
	}
}
int strendswith(const char* bigstring, const char* endstring) {
	/* Checks if bigstring ends with the content of endstring. 0 if yes, otherwise -1 */
	if (strlen(bigstring) < strlen(endstring)) {// endstring is longer, so can't be the ending of bigstring
		return -1;
	} 
	if (strlen(bigstring) == strlen(endstring)) { // equal length, so bigstring must be exactly endstring in case of a match
		if (strcasecmp(bigstring,endstring) == 0) {
			return 0;
		}else{
			return -1;
		}
	}
	//ok, we want to compare just the ending of bigstring with endstring. everything in front of it is irrelevant
	//jump to the relevant part (the ending):
	bigstring += strlen(bigstring)-strlen(endstring);
	//now check if this part is similar
	if (strcasecmp(bigstring,endstring) == 0) {
		return 0;
	}else{
		return -1;
	}
}
int onlyspaces(const char* vstring) {
	int r = 0;
	while (vstring[r] != 0 && r < 1000) {
		if (vstring[r] != 32 && vstring[r] != 9) {return -1;}
		r += 1;
	}
	return 0;
}
void trimright(char* vstring) {
	if (vstring == NULL) {return;}
	if (strlen(vstring) < 1) {return;}
	while (vstring[strlen(vstring) - 1] == 32 || vstring[strlen(vstring) - 1] == 9 || vstring[strlen(vstring) - 1] == '\n' || vstring[strlen(vstring) - 1] == '\r') {
		vstring[strlen(vstring) - 1] = 0;//cut last char because it is a space char
		if (strlen(vstring) <= 0) {return;}
	}
}
void trimleft(char* str) {
	if (str == NULL) {return;}
	unsigned int i = 0;
	while (i < strlen(str)) {
		if (str[i] != ' ' && str[i] != 9 && str[i] != '\n' && str[i] != '\r') {
			break;
		}
		i++;
	}
	if (i > 0) {
		cut(str,i);
	}
}
void cutonfirstspace(char* str) {
	if (str == NULL) {return;}	
	unsigned int count;
	count = 0;
	while (count < strlen(str)) {
		if (str[count] == 32 || str[count] == 9 || str[count] == '\n') {
			str[count] = 0;
			return;
		}
		count += 1;
	}
}
void fixlinebreaks(char* buf, int len) {
	/* This will replace a single \r with \n and \r\n with \n\040 (a leading space char).
	   The space char is there to increase performance by not shifting the whole following output around to
	   get rid of that byte in between. */
	int z = 0;
	while (z < len-1) {
		if (buf[z] == '\r') {
			buf[z] = '\n';
			if (buf[z+1] == '\n') {
				buf[z+1] = 32;
			}
		}
		z += 1;
	}
}
void addtobuf(char* buf, char byte, unsigned int maxlen) {
	if (strlen(buf) < maxlen-1) {
		buf[strlen(buf)+1] = 0;
		buf[strlen(buf)] = byte;
	}
}
int isipv4ip(const char* str) {
	char val[] = "";
	int octet = 1;int octetlen = 0;
	int previousiscolon = 1;
	int r = 0;
	while (r < strlen(str)) {
		if (str[r] < '0' || str[r] > '9') {
			if (str[r] == '.' && previousiscolon == 0) {
				octet++;octetlen = 0;
				if (octet > 4) {return -1;}
				if (atoi(val) > 255) {return -1;}
				strcpy(val,"");
				previousiscolon = 1;
				r++;continue;
			}
			return -1;
		}else{
			previousiscolon = 0;
			octetlen++;
			if (octetlen > 3) {return -1;}
			val[strlen(val)+1] = 0;
			val[strlen(val)] = str[r];
		}
		r++;
	}
	if (octet < 3 || previousiscolon == 1) {return -1;}
	return 0;
}
int isipv6ip(const char* str) {
	return -1;
}