//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

int configbindparse_Do(const char* line, char* interface, int* port, int* iptype) {
	char ip[IPMAXLEN+3];
	char vport[10];
	strcopy(ip,line,IPMAXLEN+2);
	if (charpos(ip,'/') <= 0) {
		if (charpos(ip,'/') == 0) {
			cerr("Expecting value in front of '/' seperator",creader_GetLine());return -1;
		}
		cerr("Expecting '/' seperator",creader_GetLine());return -1;
	}
	char buf[80];
	strcopy(buf,line,79);
	cut(buf,charpos(ip,'/')+1);trimleft(buf);
	ip[charpos(ip,'/')] = 0;trimright(ip);
	strcopy(vport,buf,9);
	if (charpos(vport,'/') <= 0) {
		if (charpos(vport,'/') == 0) {
			cerr("Expecting value in front of '/' seperator",creader_GetLine());return -1;
		}
		//ok, given the ip is not "any" but clearly ipv4 or ipv6 this doesn't matter:
		if (charpos(ip,':') > 0 && charpos(ip,'.') < 0) {
			strcpy(buf,"ipv6");
		}else{
			if (charpos(ip,'.') > 0 && charpos(ip,':') < 0) {
				strcpy(buf,"ipv4");
			}else{
				cerr("Expecting '/' seperator",creader_GetLine());return -1;
			}
		}
	}else{
		cut(buf,charpos(buf,'/')+1);
		vport[charpos(vport,'/')] = 0;
	}
	if (issimplenumber(vport) != 0 || atoi(vport) <= 0 || atoi(vport) > 99999) {
		cerr("Expecting 1-99999 number for second parameter",creader_GetLine());return -1;
	}
	if (strcasecmp(buf,"ipv4") != 0 && strcasecmp(buf,"ipv6") != 0) {
		cerr("Expecting 'ipv4' or 'ipv6' for third parameter",creader_GetLine());return -1;
	}
	if (strcasecmp(buf,"ipv4") == 0 && isipv4ip(ip) != 0 && strcasecmp(ip,"any") != 0) {
		cerr("Expecting valid ipv4 address or 'any' as first parameter",creader_GetLine());return -1;
	}
	if (strcasecmp(buf,"ipv6") == 0 && isipv6ip(ip) != 0 && strcasecmp(ip,"any") != 0) {
		cerr("Expecting valid ipv6 address or 'any' as first parameter",creader_GetLine());return -1;
	}
	strcpy(interface,ip);
	*port = atoi(vport);
	if (strcasecmp(buf,"ipv6") == 0) {
		*iptype = IPTYPE_IPV6;
	}else{
		*iptype = IPTYPE_IPV4;
	}
	return 0;
}