//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

int option_allowroot = 0;
int option_noexcessflood = 0;
int option_nofork = 0;

int evaluateParams(const char* params) {
	char lclbuf[500];strncpy(lclbuf,params,499);lclbuf[499] = 0;
	trimleft(lclbuf);trimright(lclbuf);
	char tmp[500];
	while (strlen(lclbuf) > 0) {
		strcpy(tmp,lclbuf);
		if (charpos(lclbuf,' ') >= 0) {
			tmp[charpos(lclbuf,' ')] = 0;
			cut(lclbuf,charpos(lclbuf,' ')+1);
			trimleft(lclbuf);
		}else{
			strcpy(lclbuf,"");
		}
		if (strcasecmp(tmp,"-v") == 0 || strcasecmp(tmp,"--version") == 0 || strcasecmp(tmp,"/v") == 0) {
			printf("WeIRCd%s-%s: %s\n",version_detail,osname,extensioninfo());
			return 0;
		}
		if (strcasecmp(tmp,"-h") == 0 || strcasecmp(tmp,"-?") == 0 || strcasecmp(tmp,"--help") == 0 || strcasecmp(tmp,"/?") == 0) {
			//printf("WeIRCd%s (%s)\n",bigversion,osname);
#ifndef WIN
			char sep[2] = "/";if (strendswith(BINDIR,"/") == 0) {strcpy(sep,"");}
			printf("Usage: %s%sweircd [options]\n",BINDIR,sep);
#endif
#ifdef WIN
			printf("Usage: weircd.exe [options]\n");
#endif
			printf("Possible command line options are:\n");
			printf("    -h  --help\n");
			printf("            Display this help text\n");
#ifndef WIN
			printf("        --allow-root\n");
			printf("            Disable root protection so that WeIRCd\n");
			printf("            won't change uid to a non-root user account\n");
			printf("            on startup instead of continuing to use root\n");
			printf("            privileges [NOT recommended]\n");
#endif
			printf("    -l  --list-mods\n");
			printf("            List all modules to be found\n");
			printf("        --mod-info <module%s>\n",modext);
			printf("            Show detailed info about a module, e.g.\n");
			printf("            the module version, author etc.\n");
			printf("            Will only work with a proper WeIRCd module\n");
			printf("    -f  --no-flood\n");
			printf("            Disable flood protection globally so that\n");
			printf("            a user can only be possibly kicked by a\n");
			printf("            full sendqueue [NOT recommended]\n");
#ifndef WIN
			printf("    -n  --no-fork\n");
			printf("            Don't daemonize at startup\n");
#endif
			printf("    -v  --version\n");
			printf("            Show the detailed program version\n");
			return 0;
		}
#ifndef WIN
		if (strcasecmp(tmp,"--allow-root") == 0) {
			option_allowroot = 1;
			continue;
		}
#endif
		if (strcasecmp(tmp,"--list-mods") == 0 || strcasecmp(tmp,"-l") == 0) {
			printmodulelist(NOUSER, NULL);
			return 0;
		}
		if (strcasecmp(tmp,"--no-flood") == 0 || strcasecmp(tmp,"-f") == 0) {
			option_noexcessflood = 1;
			continue;
		}
#ifndef WIN
		if (strcasecmp(tmp,"--no-fork") == 0 || strcasecmp(tmp,"-n") == 0) {
			option_nofork = 1;
			continue;
		}
#endif
		printf("Unknown command line option: %s\n",tmp);
		return -1;
	}
	return 1;
}
int evaluateParams_linux(int argc,const char** argv) {
	if (argc <= 1) {return 1;}
	char buf[500];strcpy(buf,"");
	int r = 1;
	while (r < argc) {
		if (r > 1) {stradd(buf," ",499);}
		stradd(buf,argv[r],499);
		r++;
	}
	return evaluateParams(buf);
}