//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

struct weircdgline* glines[COMPILEOPTION_MAXGLINES];
int glines_inited = 0;
void initgklines() {
	if (glines_inited == 1) {return;}
	glines_inited = 1;
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		glines[k] = NULL;
		k++;
	}
}
char pathbuf[500];
const char* gkfilepath(int global) {
	char configpath[60];
	if (global == 0) {
		strncpy(configpath,config_StrVal("klinefilepath"),59);
	}else{
		strncpy(configpath,config_StrVal("glinefilepath"),59);
		//r = fopen(config_StrVal("glinefilepath"),"w");
	}
	configpath[59] = 0;
	strcpy(pathbuf,configpath);
	if (strstw(configpath,"./") != 0 && strstw(configpath,"/") != 0) {
		char globaldata[150];char seperator[2];
		strcpy(seperator,"/");
		if (strendswith(datadir,"/") == 0 || strlen(datadir) <= 0) {strcpy(seperator,"");}
		snprintf(globaldata,149,"%s%s",datadir,seperator);globaldata[149] = 0;
		snprintf(pathbuf,499,"%s%s",globaldata,configpath);
		pathbuf[499] = 0;
	}
	return pathbuf;
}
void freegklines() {
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			free(glines[k]->mask);
			free(glines[k]->reason);
			free(glines[k]);
			glines[k] = NULL;
		}
		k++;
	}
}
int readglines(int global) { //read glines from gline.db
	initgklines();
	if (global == 1) {freegklines();}
	int k;
	FILE *r;
	if (global == 1) {
		r = fopen(gkfilepath(1),"r");
		if (!r) {printf("%s    > gline file (%s) not existant yet\n",startupprefixsub,gkfilepath(1));return 0;}//file is just not created yet, so we don't have any glines
	}else{
		r = fopen(gkfilepath(0),"r");
		if (!r) {printf("%s    > kline file (%s) not existant yet\n",startupprefixsub,gkfilepath(0));return 0;}
	}
	char line[300];
	char tmp[300];
	char tmp2[300];
	long long exp;k = -1;
	while (fgets(line, 300, r) != NULL) {
		if (strlen(line) > 0) {
			if (charpos(line,'!') <= 0) {
				fclose(r);return -1;
			}
			if (charpos(line,' ') <= charpos(line,'!')) {
				fclose(r);return -1;
			}
			strcpy(tmp,line);
			tmp[charpos(tmp,' ')] = 0;cut(line,charpos(line,' ')+1);
			if (charpos(line,' ') <= 0) {
				fclose(r);return -1;
			}
			strcpy(tmp2,line);
			tmp2[charpos(tmp2,' ')] = 0;cut(line,charpos(line,' ')+1);
			exp = atoll(tmp2);if (exp < 0) {fclose(r);return -1;}
			trimleft(line);
			if (strlen(line) <= 0) {fclose(r);return -1;}
			k++;
			glines[k] = malloc(sizeof(struct weircdgline));
			if (glines[k] == NULL) {
				printf("!!! Memory allocation failed\n");
				fclose(r);return -1;
			}
			memset(glines[k],0,sizeof(struct weircdgline));
			glines[k]->mask = malloc(strlen(tmp)+1);
			if (glines[k]->mask == NULL) {
				printf("!!! Memory allocation failed\n");
				free(glines[k]);
				glines[k] = NULL;
				fclose(r);return -1;
			}
			glines[k]->reason = malloc(strlen(line)+1);
			if (glines[k]->reason == NULL) {
				printf("!!! Memory allocation failed\n");
				free(glines[k]);
				free(glines[k]->mask);
				glines[k] = NULL;
				fclose(r);return -1;
			}
			glines[k]->expiretime = exp;
			glines[k]->global = 1;
			strcpy(glines[k]->mask,tmp);
			strcpy(glines[k]->reason,line);
			glines[k]->global = global;
			if (strlen(glines[k]->reason) > 499) {fclose(r);return -1;}
			if (k >= COMPILEOPTION_MAXGLINES-1) {break;}
		}
	}
	fclose(r);
	if (global == 1) {
		printf("%s    > %d gline(s) loaded\n",startupprefixsub,k+1);
	}else{
		printf("%s    > %d kline(s) loaded\n",startupprefixsub,k+1);
	}
	return 0;
}
char printexpbuf[200];
const char* printexp(long long time) {
	if (time < 0) {time = 1;}
	int days = 0;
	int hours = 0;
	int minutes = 0;
	int seconds = 0;
	if (time == 0) {strcpy(printexpbuf,"never");return printexpbuf;}
	while (time >= 24*60*60) {
		days += 1;
		time -= 24*60*60;
	}
	while (time >= 60*60) {
		hours += 1;
		time -= 60*60;
	}
	while (time >= 60) {
		minutes += 1;
		time -= 60;
	}
	seconds = time;
	char tmp[20];
	strcpy(printexpbuf,"after ");
	if (minutes > 3 || hours > 0 || days > 0) {seconds = 0;}
	if (days > 0) {minutes = 0;}
	if (days > 20) {hours = 0;}
	if (days > 0) {sprintf(tmp,"%dd",days);strcat(printexpbuf,tmp);}
	
	if (hours > 0) {sprintf(tmp,"%dh",hours);strcat(printexpbuf,tmp);}
	
	if (minutes > 0) {sprintf(tmp,"%dm",minutes);strcat(printexpbuf,tmp);}
	
	if (seconds > 0 || (days == 0 && hours == 0 && minutes == 0)) {sprintf(tmp,"%ds",seconds);strcat(printexpbuf,tmp);}
	
	return printexpbuf;
}
void listgklines(USER userid, int global) {
	initgklines();
	int k;
	k = 0;
	char ch = 'G';
	if (global == 0) {ch = 'K';}
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			if (glines[k]->global == global) {
				if (glines[k]->expiretime != 0) {
					usnd(userid,":%s NOTICE %s :%cline: %s (%s): %s",svname(),udat(userid)->nickname,ch,glines[k]->mask,printexp((glines[k]->expiretime-ts())+1),glines[k]->reason);
				}else{
					usnd(userid,":%s NOTICE %s :%cline: %s (%s): %s",svname(),udat(userid)->nickname,ch,glines[k]->mask,printexp(0),glines[k]->reason);
				}
			}
		}
		k++;
	}
	usnd(userid,":%s NOTICE %s :End of %cline list",svname(),udat(userid)->nickname,ch);
}
void savegklines(int global) {
	initgklines();
	FILE *r;
	r = fopen(gkfilepath(global),"w");
	if (!r) {return;}//bad, but nothing we can do
	int k = 0;
	while (k < COMPILEOPTION_MAXKLINES) {
		if (glines[k] != NULL) {
			if (glines[k]->global == global) {
				#ifndef WIN
				fprintf(r,"%s %lld %s",glines[k]->mask,glines[k]->expiretime,glines[k]->reason);
				#else
				fprintf(r,"%s %I64d %s",glines[k]->mask,glines[k]->expiretime,glines[k]->reason);
				#endif
				
			}
		}
		k++;
	}
	fclose(r);
}
void saveglines() {
	savegklines(1);
}
void saveklines() {
	savegklines(0);
}
void glineusers(const char* mask, USER ircop, const char* reason, int global) {
	char umask[500];
	char longreason[500];
	char ch = 'G';if (global == 0) {ch = 'K';}
	snprintf(longreason,499,"%c-line by %s: %s",ch,udat(ircop)->nickname,reason);
	longreason[499] = 0;
	usr_CycleInit();
	USER u = usr_DoCycle();
	while (u != NOUSER) {
		if (udat(u)->pleaseremove == 0 && udat(u)->authed == 1 && udat(u)->mode_servicesbot == 0) {
			int match = 0;
			snprintf(umask,499,"%s!%s@%s",udat(u)->nickname,udat(u)->suserid,udat(u)->host);
			umask[499] = 0;
			if (masks_Match(umask,mask) == 0) {
				match = 1;
			}			
			if (match == 0) {
				//check with ip instead of host
				if (strstw(mask,"*!*@") == 0) {
					if (masks_Match(udat(u)->ip,mask+strlen("*!*@")) == 0) {
						match = 1;
					}
				}
			}
			if (match == 1) {
				udat(u)->quitreason = malloc(strlen(longreason) + 1);
				if (udat(u)->quitreason != NULL) {
					strcpy(udat(u)->quitreason,longreason);
					usnd(u,"ERROR :%c-lined by %s: %s",ch,udat(u)->nickname,reason);
				}
				userQuit(u,USERQUIT_ERROR);
			}
		}
		u = usr_DoCycle();
	}
}
char glinedbuffer[500];
const char* glined(USER userid, int global) {
	initgklines();
	char umask[500];
	snprintf(umask,499,"%s!%s@%s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host);
	umask[499] = 0;
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			if (glines[k]->global == global && masks_Match(umask,glines[k]->mask) == 0) {
				strcpy(glinedbuffer,glines[k]->reason);
				return glinedbuffer;
			}
		}
		k++;
	}
	return NULL;
}
const char* glinedbyip(const char* ip, int global) {
	initgklines();
	char umask[500];
	snprintf(umask,499,"*!*@%s",ip);
	umask[499] = 0;
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			if (strstw(glines[k]->mask,"*!*@") == 0) {
				char* p = glines[k]->mask + strlen("*!*@"); 
				if (glines[k]->global == global && masks_Match(ip,p) == 0) {
					strcpy(glinedbuffer,glines[k]->reason);
					return glinedbuffer;
				}
			}
		}
		k++;
	}
	return NULL;
}
void delgkline(USER userid, const char* mask, int global) {
	char newmask[MAXUSERMASKLEN+1];
	strncpy(newmask,mask,MAXUSERMASKLEN);
	newmask[MAXUSERMASKLEN] = 0;
	masks_MakeValid(newmask);
	initgklines();
	char ch = 'g';if (global == 0) {ch = 'k';}
	char response[500];
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			if (strcasecmp(glines[k]->mask,newmask) == 0 && glines[k]->global == global) {
				snprintf(response,499,"%c%s removes %cline on %s%c",2,udat(userid)->nickname,ch,glines[k]->mask,2);
				response[499] = 0;
				IOnotice(response);
				free(glines[k]->mask);
				free(glines[k]->reason);
				free(glines[k]);
				glines[k] = NULL;
				return;
			}
		}
		k++;
	}
	usnd(userid,":%s NOTICE %s :%cLine %s not found.",svname(),udat(userid)->nickname,ch,mask);
	return;
}
void addgkline(USER userid, const char* mask, const char* vtime, const char* vreason,int global) {
	initgklines();
	char response[500];
	char reason[500];
	strncpy(reason,vreason,499);reason[499] = 0;
	trimleft(reason);trimright(reason);
	char ch = 'G';if (global == 0) {ch = 'K';}
	if (strlen(reason) < 1) {
		usnd(userid,":%s NOTICE %s :Please always give a reason for %c-line.",svname(),udat(userid)->nickname,ch);
		return;
	}
	long long exp;
	if (strlen(reason) <= 0) {
		return;
	}
	if (parsetime(vtime,&exp) < 0) {
		usnd(userid,":%s NOTICE %s :Invalid expiration time value. '5d2h' (5 days, 2 hours) or similar expected ('0' for never).",svname(),udat(userid)->nickname);
		return;
	}
	char valmask[MAXUSERMASKLEN+1];
	if (valmask == NULL) {
		usnd(userid,":%s NOTICE %s :%c-line failed: Out of memory",svname(),udat(userid)->nickname,ch);
		return;
	}
	strncpy(valmask,mask,MAXUSERMASKLEN);valmask[MAXUSERMASKLEN] = 0;
	masks_MakeValid(valmask);
	char umask[900];
	sprintf(umask,"%s!%s@%s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host);
	if (masks_Match(umask,valmask) == 0) {
		usnd(userid,":%s NOTICE %s :You cannot %c-line yourself.",svname(),udat(userid)->nickname,ch);
		return;
	}
	char renews[12] = "sets";
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			if (strcasecmp(glines[k]->mask,valmask) == 0 && glines[k]->global == global) {
				strcpy(renews,"refreshes");
				free(glines[k]->reason);
				free(glines[k]->mask);
				free(glines[k]);
				glines[k] = NULL;
				break;
			}
		}
		k++;
	}
	k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] == NULL) {
			glines[k] = malloc(sizeof(struct weircdgline));
			if (glines[k] == NULL) {
				usnd(userid,":%s NOTICE %s :%c-line failed: Out of memory",svname(),udat(userid)->nickname,ch);
				return;
			}
			memset(glines[k],0,sizeof(struct weircdgline));
			glines[k]->mask = malloc(strlen(valmask)+1);
			glines[k]->reason = malloc(strlen(reason)+1);
			glines[k]->global = global;
			if (glines[k]->mask == NULL || glines[k]->reason == NULL) {
				if (glines[k]->mask != NULL) {free(glines[k]->mask);}
				if (glines[k]->reason != NULL) {free(glines[k]->reason);}
				free(glines[k]);
				usnd(userid,":%s NOTICE %s :%c-line failed: Out of memory",svname(),udat(userid)->nickname,ch);
				return;
			}
			strcpy(glines[k]->mask,valmask);
			strcpy(glines[k]->reason,reason);
			if (exp > 0) {
				glines[k]->expiretime = ts() + exp;
			}else{
				glines[k]->expiretime = 0;
			}
			snprintf(response,499,"%c%s %s %c-line on %s%c (expires %s)",2,udat(userid)->nickname,renews,ch,valmask,2,printexp(exp));
			response[499] = 0;
			IOnotice(response);
			glineusers(valmask,userid,reason,global);
			return;
		}
		k++;
	}
	usnd(userid,":%s NOTICE %s :%c-line failed: Already too many %c-lines",svname(),udat(userid)->nickname,ch,ch);
	return;
}
void expiregklines() {
	initgklines();
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			if (glines[k]->expiretime != 0) {
				if (glines[k]->expiretime < ts()) {
					free(glines[k]->mask);
					free(glines[k]->reason);
					free(glines[k]);
					glines[k] = NULL;
				}
			}
		}
		k++;
	}
}

