//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2010 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void irc_UserCMD(USER userid, const char* command, const char* parameters);
void irc_SendAuthPong(USER userid);
void irc_SendStartupNotice(USER userid);
void irc_MakeUserIdValid(char* userid);
void irc_SendTime(USER userid);
void irc_SendWhois(USER userid,USER targetid);
void irc_SendWho(CHANNEL chan, USER user, USER targetuser);
void irc_SendNames(USER user, CHANNEL chan);
void irc_SendTopic(USER userid, CHANNEL chan);
void irc_Send001(USER userid);
void irc_SendInfo(USER u);
void irc_DoRehash(USER triggeringuser);

void irc_ClearRestrictedCache(CHANNEL chan);
void irc_ClearRestrictedCacheOfUser(USER u, CHANNEL chan);

int irc_IsRestricted(USER userid, CHANNEL chan);
int irc_IsUserBanned(USER userid, CHANNEL chan);
int irc_IsValidHost(const char* hostname);
int irc_IsForbiddenNick(const char* n);
int irc_IsNicknameValid(const char* nick);
int irc_IsNickUsed(const char* nick);
int irc_IsUserBanned(USER userid, CHANNEL chan);

void irc_ChangeUserHost(USER userid, const char* hostname);

void irc_ParseMsgCMD(USER userid, const char* type, char** params, int count);

void irc_LocalJoin(USER userid, const char* channame, const char* password); // a join that needs to be announced to linked servers

void moveintochan(USER userid,const char* channame, const char* pw); // move a user into a channel without announcing it

void notenoughparameters(USER userid, const char* command); //convenience function to emit the respective message

void irc_ClearBanCache(CHANNEL chan); //needs to be called when any channel ban is set or removed

#define COUNT_ALL 1
#define COUNT_LOCAL 2
#define COUNT_OPS 3
int irc_UserCount(int type);

void irc_ModesForUser(USER userid, char* buf, int buflen);