//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void links_Broadcast(const char* str);
void links_Forward(const char* str, int exceptlink);
void links_SendByUID(const char* str, USER user);
void links_SendBySID(const char* str, int serverlink);

/* link types */
#define LINKTYPE_ACTIVE 1
#define LINKTYPE_PASSIVE 2

/* open up a new link */
void* links_Add(int isactive, const char* interface, int port, int iptype, const char* protocol, const char* sendpassword, const char* recvpassword, void* dependson);
int links_IsModuleNeeded(const char* name);
int links_Activate(const char* tg, int port); //use port = -1 for active links, specify exactly for passive links

/* cycling all ids associcated with a module (used by the module linking api) */
void links_StartIDCycle(const char* modname);
int links_DoIDCycle();

struct weircdlink {
	// type (active, passive)
	int type;
	// connection data
	int port;
	int iptype;
	char* interface;
	// login data. only present for active links. passive will search the respective active entry (and have NULL here)
	char* sendpassword;
	char* recvpassword;
	// protocol used
	char* protmodule;
	// is it active? otherwise, this will be -1
	int activeconnectionid;
	// a data pointer to be set by the module. hell knows what it will be used for :p
	void* dataptr;
	// a pointer to the associated passive link entry
	void* dependson;
};
extern void* listoflinks;