//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

int floodpointmax() {
	if (config_IntVal("floodlevel") == FLOODLEVEL_STRICT) {
		return 10;
	}
	if (config_IntVal("floodlevel") == FLOODLEVEL_MEDIUM) {
		return 15;
	}
	if (config_IntVal("floodlevel") == FLOODLEVEL_SOFT) {
		return 20;
	}
	return 15;
}

int floodmanager_IsUserFlooding(USER u) {
	int floodmax = floodpointmax();
	if (udat(u)->floodprotect.floodpoints > floodmax) {
		if (option_noexcessflood == 0 && udat(u)->mode_noflood == 0 && udat(u)->mode_servicesbot == 0) {
			return 0;
		}else{
			udat(u)->floodprotect.floodpoints = 0;
		}
	}
	return -1;
}

long lastfloodtime = 0;
void floodmanager() {
	usr_CycleInit();
	int dolowering = 0;
	if (lastfloodtime < ts()) {dolowering = 1;}
	USER u = usr_DoCycle();
	while (u != NOUSER) {
		if (udat(u)->pleaseremove == 0 && udat(u)->hopcount <= 0) {
			if (dolowering == 1) {
				udat(u)->floodprotect.floodpoints -= 2;
				if (udat(u)->floodprotect.floodpoints < 0) {
					udat(u)->floodprotect.floodpoints = 0;
				}
			}
			if (floodmanager_IsUserFlooding(u) == 0) {
				usnd(u,"ERROR :Closing Link: Excess flood");
				userQuit(u,USERQUIT_EXCESSFLOOD);
			}
		}
		u = usr_DoCycle();
	}
	lastfloodtime = ts();
}
#ifdef WIN
void writestatus() {
	char pathbuf[100];
	if (GetTempPath(99,pathbuf) <= 0) {return;}
	char tg[150];
	strcopy(tg,pathbuf,149);
	if (strendswith(tg,"/") != 0) {
		stradd(tg,"/",149);
	}
	stradd(tg,"weircd-status",149);
	FILE* r = fopen(tg,"wb");
	if (!r) {return;}
	fprintf(r,"users-local-current %d\nusers-global-current %d\nopers %d\n",irc_GetUserCount(COUNT_LOCAL),irc_GetUserCount(COUNT_ALL),irc_GetUserCount(COUNT_OPS));
	fclose(r);
}
#endif
int mainloop_go() {
#ifdef WIN
	long laststatuswritetime = 0;
#endif
	while (willquit == 0) {
#ifdef WIN
		if (laststatuswritetime < time(NULL)) {
			laststatuswritetime = time(NULL);
			writestatus();
		}
#endif
		int r = so_SelectWait(800);
		if (r > 0) {
			if (wantsend > 0) {
				weircd_sockets_ExecuteHooks(1,1);
			}else{
				weircd_sockets_ExecuteHooks(1,0);
			}
		}
		usr_PingAndRemove();
		floodmanager();
		if (r > 0) {
			userman_CheckConnections();
			userman_ProceedReceiving();
		}
		floodmanager();
		expiregklines();
		usr_PingAndRemove();
		userman_ProceedSending();
		FakeUsers_ProceedAll();
		usr_PingAndRemove();
		ips_AutoRemove();
#ifdef WIN
		//a little message queue for "signals" sent by an admin panel
		MSG b;
		while (PeekMessage(&b, NULL, 0, 0, PM_REMOVE) != 0) {
			if (b.message == WM_APP+2) {
				willquit = 1;
			}
			if (b.message == WM_APP+3) {
				irc_DoRehash(NOUSER);
			}
		}
#endif
	}
	//linktcp_closeforshutdown();
	//close down modules (services, linking, ...)
	modules_ShutdownAll();
	//close down user connections
	usr_CloseAllConnectionsForShutdown();
	//close down listeners
	userman_CloseListenersForShutdown();
	//save glines & klines
	saveglines();
	saveklines();
	//clear config related stuff
	listdata_ClearNew();
	return 0;
}
